/*
   File: lc_rel.h
   Determines the left corner relation for affix rules and syntax rules
   Additionally, all nasty left corners (hidden cyclicity) are found.

   Copyright (C) 2011 Marc Seutter

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   CVS ID: "$Id: lc_rel.h,v 1.2 2011/12/16 15:45:21 marcs Exp $"
*/
#ifndef IncLcRel
#define IncLcRel

/* standard includes */
#include <stdio.h>

/* libdcg includes */
#include <dcg.h>
#include <dcg_alloc.h>
#include <dcg_string.h>

/* local includes */
#include "eag_ds.h"

/* exported left corner relation for syntax rules */
extern char *rules_lc_rel;
void determine_lc_relation_in_affix_rules ();
void determine_lc_relation_in_rules ();

#endif /* IncLcRel */
